
class Estadisticas extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      opcion : 0,
      lista_sesiones : [],
      lista_pedidos: [],
      lista_productos : []
    }
    this.cambiarOpcion = this.cambiarOpcion.bind(this)
    this.obtenerSesiones = this.obtenerSesiones.bind(this)

    //obtenerPedidos();
    this.obtenerSesiones();
  }
  cambiarOpcion(nueva_opcion){
    this.setState({
      opcion : nueva_opcion
    })
  }

  obtenerSesiones(){

    var comp = this;

    $.ajax({
        type:"POST",
        url:"https://www.tfg.carlosh.es/admin/api/obtener_sesiones.php",
        success:function(datos){
            comp.setState({lista_sesiones: datos.array});
            console.table(comp.state.lista_sesiones)
         },
         dataType : "json"
    })

  }

  render() {
    let final;
    if(this.state.opcion ==0){
      final = <Sesiones  info ={this.state.lista_sesiones}/>
    }else if (this.state.opcion ==1){
      final = <Facturacion />
    }else if (this.state.opcion ==2){
          final = <Productos_count />
    }

    var clases = [];
    for(var i =0 ; i< 4 ; i++){
      clases[i] = "btn ";

      if(i == this.state.opcion) clases[i] += "btn-primary";
      else clases[i] += "btn-light";
    }

    return  <div>
    <div className="btn-group-sm" style={{width: "100%"}}>
      <button className={clases[0]} onClick ={(e) => this.cambiarOpcion(0)}>Sesiones <span class="badge badge-light"></span></button>
      <button className={clases[1]} onClick ={(e) => this.cambiarOpcion(1)}>Facturación <span class="badge badge-light"></span></button>
      <button className={clases[2]} onClick ={(e) => this.cambiarOpcion(2)}>Productos más pedidos<span class="badge badge-light"></span></button>

    </div>
     {final}
     </div>
  }
}



class Sesiones extends React.Component {
  constructor(props) {
    super(props)
  }
  render(){
      var lista = this.props.info.map((sesion) =>
      <div className="card" style={{paddingLeft:"10px"}}>
        <div className="row">
          <div className="col-8 text-left">
            <p>Fecha inicio:{sesion.fecha_inicio}</p>
            <p>Fecha fin:{sesion.fecha_fin}</p>
          </div>
          <div className="col-4 text-left">
            <p style={{bottom:"0px"}}>{sesion.precioTotal} €</p>
          </div>
        </div>
      </div>
    )
    return lista
  }
}


class Facturacion extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      lista_valores :[],
      lista_fechas :[]

    }
    this.obtenerFacturacion = this.obtenerFacturacion.bind(this)
    this.obtenerFacturacion();
  }
  obtenerFacturacion(){
    var comp = this;

    $.ajax({
        type:"POST",
        url:"https://www.tfg.carlosh.es/admin/api/obtener_facturacion.php",
        data : {
          fecha_inicio : $("#fecha_inicio").val(),
          fecha_fin : $("#fecha_fin").val(),
          opcion : $("#opcion").val()
        },
        success:function(datos){
            comp.setState({lista_valores: datos.lista_valores});
            comp.setState({lista_fechas: datos.lista_fechas});
            console.log(datos)
         },
         dataType : "json"
    })
  }

  componentDidMount() {

    console.table(this.state.lista_valores)

    $('#myChart').remove();
    $('#chart-container').append('<canvas id="myChart"><canvas>');
    var ctx = document.getElementById('myChart').getContext('2d');
    var chart = new Chart(ctx, {
        type: 'line',
        data: {
            labels: this.state.lista_fechas,
            datasets: [{
                label: '',
                backgroundColor: 'rgb(255, 99, 132)',
                borderColor: 'rgb(255, 99, 132)',
                data:  this.state.lista_valores
            }]
        },
        // Configuration options go here
        options: {
          scales: {yAxes: [{ticks: {beginAtZero: true}}]},
          tooltips: {callbacks: {label: (item) => `${item.yLabel} €`,},}
        }
    });
  }


  render(){


    if(document.getElementById('myChart')){
      $('#myChart').remove();
      $('#chart-container').append('<canvas id="myChart"><canvas>');
      var ctx = document.getElementById('myChart').getContext('2d');

      var chart = new Chart(ctx, {
          type: 'line',
          data: {
              labels: this.state.lista_fechas,
              datasets: [{
                  label: '',
                  backgroundColor: 'rgb(255, 99, 132)',
                  borderColor: 'rgb(255, 99, 132)',
                  data:  this.state.lista_valores
              }]
          },
          // Configuration options go here
          options: {
            scales: {yAxes: [{ticks: {beginAtZero: true}}]},
            tooltips: {callbacks: {label: (item) => `${item.yLabel} €`,},}
          }
      });
    }



    return <div>
    Fecha Inicio:
    <input id="fecha_inicio" type="date" className="form-control" />
    Fecha Fin:
    <input id="fecha_fin" type="date" className="form-control" />
    <br / >
    Intervalo
    <select id="opcion" className="form-control" >
      <option value="0"> 1 Día</option>
      <option value="1"> 1 Semana</option>
      <option value="2"> 1 Mes</option>
      <option value="3"> 1 Año</option>
    </select>
    <input type="button" className="btn btn-info" value="Filtrar" onClick = {(e) => this.obtenerFacturacion()}/>
    <div id="chart-container">
    <canvas id="myChart"></canvas>
    </div>
    </div>
  }

}

class Productos_count extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      lista_valores :[],
      lista_productos :[]

    }
    this.obtenerProductos = this.obtenerProductos.bind(this)
    this.obtenerProductos();
  }
  obtenerProductos(){
    var comp = this;

    $.ajax({
        type:"POST",
        url:"https://www.tfg.carlosh.es/admin/api/obtener_productos_count.php",

        success:function(datos){
            comp.setState({lista_valores: datos.lista_valores});
            comp.setState({lista_productos: datos.lista_productos});
            console.log(datos)
         },
         dataType : "json"
    })
  }
  colocarGrafica(){

  }

  componentDidMount() {

    console.table(this.state.lista_productos)

    console.table(this.state.lista_valores)


    /*
    $('#myChart').remove();
    $('#chart-container').append('<canvas id="myChart"><canvas>');
    var ctx = document.getElementById('myChart').getContext('2d');
    var chart = new Chart(ctx, {
        type: 'line',
        data: {
            labels: this.state.lista_productos,
            datasets: [{
                label: '',
                backgroundColor: 'rgb(255, 99, 132)',
                borderColor: 'rgb(255, 99, 132)',
                data:  this.state.lista_valores
            }]
        },
        // Configuration options go here
        options: {
          scales: {yAxes: [{ticks: {beginAtZero: true}}]},
          tooltips: {callbacks: {label: (item) => `${item.yLabel} €`,},}
        }
    });
    */
  }


  render(){
    if(document.getElementById('myChart')){
      $('#myChart').remove();
      $('#chart-container').append('<canvas id="myChart"><canvas>');
      new Chart(document.getElementById("myChart"), {
      type: 'bar',
      data: {
        labels: this.state.lista_productos,
        datasets: [
          {
            label: "Número de pedidos",
            backgroundColor: ["#E5BB33", "#C0C0C0","#964B00"],
            data: this.state.lista_valores
          }
        ]
      },
      options: {
        legend: { display: false },
        scales: {
            yAxes: [{
                ticks: {
                    beginAtZero: true
                }
            }]
        }
      }
      });
    }
    return <div>
    <div id="chart-container">
    <canvas id="myChart"></canvas>
    </div>
    </div>
  }

}






ReactDOM.render(<Estadisticas />, document.getElementById('tabla'));
